SystemOrganization addCategory: #Smutty!
SystemOrganization addCategory: 'Smutty-Tests'!
SystemOrganization addCategory: 'Smutty-Web'!
SystemOrganization addCategory: 'Smutty-Web-Tests'!

TestCase subclass: #QuestStateTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!QuestStateTest commentStamp: '<historical>' prior: 0!
A QuestStateTest is a test class for testing the behavior of QuestState!

!QuestStateTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/3/2015 07:41'!
test_01_advancingTheQuest
	| quest questState questAdvancer action |
	
	quest := StoryMap example.
	questState := QuestState on: quest.
	questAdvancer := QuestAdvancer new.
	action := QuestAction description: 'Win!!'.
	
	self assert: questState currentNode = quest nodes first.
	questAdvancer advance: questState with: action.
	self assert: questState currentNode = quest nodes last.! !

TestCase subclass: #StoryMapTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!StoryMapTest commentStamp: '<historical>' prior: 0!
A StoryMapTest is a test class for testing the behavior of StoryMap!

!StoryMapTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 6/5/2015 20:59'!
test_01_example

	| story |
	story := StoryMap example.
	self assert: story beginning notNil.
	self assert: story nodes notEmpty.
	self assert: story transitions notEmpty.! !

TestCase subclass: #StoryTransitionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Tests'!

!StoryTransitionTest commentStamp: '<historical>' prior: 0!
A StoryTransitionTest is a test class for testing the behavior of StoryTransition!

!StoryTransitionTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/3/2015 08:00'!
test_01_actionDescription
	| transition placeholderOrigin placeholderDestination |
	
	placeholderOrigin := nil.
	placeholderDestination := nil.
	transition := StoryTransition origin: placeholderOrigin destination: placeholderDestination actionDescription: 'Win!!'. 
	
	self assert: (transition actionDescription = 'Win!!').! !

Object subclass: #QuestAction
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!QuestAction commentStamp: 'SergioFedi 6/5/2015 20:45' prior: 0!
I model an action that can be taken in the context of a quest or that is relevant to a quest (or quests, in general).!

!QuestAction class methodsFor: 'instance creation' stamp: 'FedericoFigueredo 6/3/2015 07:43'!
description: aString 
	^ self new description: aString.! !

!QuestAction methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 07:48'!
description
	^ description.! !

!QuestAction methodsFor: 'setter' stamp: 'FedericoFigueredo 6/3/2015 07:43'!
description: aString 
	description := aString.! !

Object subclass: #QuestAdvancer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!QuestAdvancer commentStamp: 'SergioFedi 6/5/2015 21:00' prior: 0!
This class does not model anything, it's just here for research purposes.!

!QuestAdvancer methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/3/2015 08:04'!
advance: aQuestState with: anAction 
	| relevantTransitions advancingTransitions advancingTransition |
	
	relevantTransitions := aQuestState quest transitionsFrom: aQuestState currentNode.
	advancingTransitions := relevantTransitions select: [ :each | each actionDescription = anAction description ].
	advancingTransition := advancingTransitions first.
	
	aQuestState currentNode: advancingTransition destination.! !

Object subclass: #QuestState
	instanceVariableNames: 'quest currentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!QuestState commentStamp: 'SergioFedi 6/5/2015 20:44' prior: 0!
I model a mobile point in the story-space.
That is, where/how I am withing a story.
More speciffically, a Quest.
!

!QuestState class methodsFor: 'instance creation' stamp: 'SergioFedi 6/5/2015 22:25'!
on: aQuestMap

	^ self new
		quest: aQuestMap.! !

!QuestState methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 06:54'!
currentNode
	^ currentNode.! !

!QuestState methodsFor: 'setter' stamp: 'FedericoFigueredo 6/3/2015 07:05'!
currentNode: aStoryNode 
	currentNode := aStoryNode.! !

!QuestState methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 07:23'!
quest
	^ quest.! !

!QuestState methodsFor: 'setter' stamp: 'FedericoFigueredo 6/3/2015 07:04'!
quest: aStoryMap 
	quest := aStoryMap.
	self currentNode: aStoryMap beginning.! !

Object subclass: #StoryMap
	instanceVariableNames: 'nodes beginning transitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!StoryMap commentStamp: 'FedericoFigueredo 6/1/2015 07:36' prior: 0!
StoryMap se define como el conjunto de pedacitos de ficción/historia y las formas en las que estos se relacionan entre si.!

!StoryMap class methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/3/2015 06:42'!
example
	| mapa nodoComienzo nodoFinal |
	
	mapa := StoryMap new.
	nodoComienzo := StoryNode text: 'Welcome to the game. It''s super hot. Wear mittens!!'.
	nodoFinal := StoryNode
		text: 'You''ve won the game. You should be proud. We hope you enjoyed the lack of any erotic content.'.
	mapa
		addStoryNode: nodoComienzo;
		addStoryNode: nodoFinal;
		startStoryOn: nodoComienzo.
	mapa fromNode: nodoComienzo youCan: 'Win!!' andGoTo: nodoFinal.
	^ mapa.! !

!StoryMap methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/1/2015 07:44'!
addStoryNode: aStoryNode 
	self nodes add: aStoryNode.! !

!StoryMap methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 07:04'!
beginning
	^ beginning.! !

!StoryMap methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/3/2015 07:59'!
fromNode: originNode youCan: aString andGoTo: destinationNode 
	self nodes addIfNotPresent: originNode; addIfNotPresent: destinationNode.
	self transitions add: (StoryTransition origin: originNode destination: destinationNode actionDescription: aString).! !

!StoryMap methodsFor: 'accessing' stamp: 'FedericoFigueredo 6/1/2015 08:08'!
initialize
	nodes := OrderedCollection new.
	transitions := OrderedCollection new.! !

!StoryMap methodsFor: 'accessing' stamp: 'FedericoFigueredo 6/1/2015 07:49'!
nodes
	^ nodes.! !

!StoryMap methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/1/2015 07:59'!
startStoryOn: aStoryNode 
	self nodes addIfNotPresent: aStoryNode.
	beginning := aStoryNode.! !

!StoryMap methodsFor: 'acessing' stamp: 'FedericoFigueredo 6/1/2015 08:08'!
transitions
	^ transitions.! !

!StoryMap methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/3/2015 07:24'!
transitionsFrom: aStoryNode 
	^ self transitions select: [ :each | each origin = aStoryNode ].! !

Object subclass: #StoryMapHtmlRendererTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty-Web-Tests'!

Object subclass: #StoryNode
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!StoryNode commentStamp: 'SergioFedi 6/5/2015 20:41' prior: 0!
I model a specific point in the story space.
For example, the beginning of a story is an instance of me.
So are the different endings.!

!StoryNode class methodsFor: 'instance creation' stamp: 'FedericoFigueredo 6/1/2015 07:38'!
text: aString 
	^ self new text: aString.! !

!StoryNode methodsFor: 'setter' stamp: 'FedericoFigueredo 6/1/2015 07:41'!
text: aString 
	text := aString.! !

Object subclass: #StoryTransition
	instanceVariableNames: 'origin destination actionDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smutty'!

!StoryTransition commentStamp: 'SergioFedi 6/5/2015 20:42' prior: 0!
I model a change from one StoryNode to another.
This includes the origin, destination and what makes the change.!

!StoryTransition class methodsFor: 'instance creation' stamp: 'FedericoFigueredo 6/3/2015 08:03'!
origin: aStoryNode destination: aStoryNode2 actionDescription: aString 
	^ self new
		origin: aStoryNode; 
		destination: aStoryNode2; 
		actionDescription: aString.		! !

!StoryTransition methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 08:02'!
actionDescription
	^ actionDescription.! !

!StoryTransition methodsFor: 'setter' stamp: 'FedericoFigueredo 6/3/2015 08:03'!
actionDescription: aString 
	actionDescription := aString.! !

!StoryTransition methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 07:25'!
destination
	^ destination.! !

!StoryTransition methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 6/2/2015 06:29'!
destination: aStoryNode 
	destination := aStoryNode.! !

!StoryTransition methodsFor: 'getter' stamp: 'FedericoFigueredo 6/3/2015 07:24'!
origin
	^ origin.! !

!StoryTransition methodsFor: 'setter' stamp: 'FedericoFigueredo 6/2/2015 06:27'!
origin: aStoryNode 
	origin := aStoryNode.! !
